/* softberryOrtho.c was originally generated by the autoSql program, which also 
 * generated softberryOrtho.h and softberryOrtho.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "softberryOrtho.h"

void softberryOrthoStaticLoad(char **row, struct softberryOrtho *ret)
/* Load a row from softberryOrtho table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->humanGene = row[0];
ret->mouseGene = row[1];
ret->humanScore = sqlUnsigned(row[2]);
ret->humanRank = sqlUnsigned(row[3]);
ret->mouseRank = sqlUnsigned(row[4]);
ret->blockCount = sqlUnsigned(row[5]);
ret->identity = atof(row[6]);
ret->identityShortest = atof(row[7]);
ret->blockMouse = atof(row[8]);
ret->blockHuman = atof(row[9]);
ret->lenMouse = sqlUnsigned(row[10]);
ret->lenHuman = sqlUnsigned(row[11]);
}

struct softberryOrtho *softberryOrthoLoad(char **row)
/* Load a softberryOrtho from row fetched with select * from softberryOrtho
 * from database.  Dispose of this with softberryOrthoFree(). */
{
struct softberryOrtho *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->humanGene = cloneString(row[0]);
ret->mouseGene = cloneString(row[1]);
ret->humanScore = sqlUnsigned(row[2]);
ret->humanRank = sqlUnsigned(row[3]);
ret->mouseRank = sqlUnsigned(row[4]);
ret->blockCount = sqlUnsigned(row[5]);
ret->identity = atof(row[6]);
ret->identityShortest = atof(row[7]);
ret->blockMouse = atof(row[8]);
ret->blockHuman = atof(row[9]);
ret->lenMouse = sqlUnsigned(row[10]);
ret->lenHuman = sqlUnsigned(row[11]);
return ret;
}

struct softberryOrtho *softberryOrthoLoadAll(char *fileName) 
/* Load all softberryOrtho from a tab-separated file.
 * Dispose of this with softberryOrthoFreeList(). */
{
struct softberryOrtho *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[12];

while (lineFileRow(lf, row))
    {
    el = softberryOrthoLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct softberryOrtho *softberryOrthoLoadWhere(struct sqlConnection *conn, char *table, char *where)
/* Load all softberryOrtho from table that satisfy where clause. The
 * where clause may be NULL in which case whole table is loaded
 * Dispose of this with softberryOrthoFreeList(). */
{
struct softberryOrtho *list = NULL, *el;
struct dyString *query = dyStringNew(256);
struct sqlResult *sr;
char **row;

dyStringPrintf(query, "select * from %s", table);
if (where != NULL)
    dyStringPrintf(query, " where %s", where);
sr = sqlGetResult(conn, query->string);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = softberryOrthoLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
dyStringFree(&query);
return list;
}

struct softberryOrtho *softberryOrthoCommaIn(char **pS, struct softberryOrtho *ret)
/* Create a softberryOrtho out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new softberryOrtho */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->humanGene = sqlStringComma(&s);
ret->mouseGene = sqlStringComma(&s);
ret->humanScore = sqlUnsignedComma(&s);
ret->humanRank = sqlUnsignedComma(&s);
ret->mouseRank = sqlUnsignedComma(&s);
ret->blockCount = sqlUnsignedComma(&s);
ret->identity = sqlFloatComma(&s);
ret->identityShortest = sqlFloatComma(&s);
ret->blockMouse = sqlFloatComma(&s);
ret->blockHuman = sqlFloatComma(&s);
ret->lenMouse = sqlUnsignedComma(&s);
ret->lenHuman = sqlUnsignedComma(&s);
*pS = s;
return ret;
}

void softberryOrthoFree(struct softberryOrtho **pEl)
/* Free a single dynamically allocated softberryOrtho such as created
 * with softberryOrthoLoad(). */
{
struct softberryOrtho *el;

if ((el = *pEl) == NULL) return;
freeMem(el->humanGene);
freeMem(el->mouseGene);
freez(pEl);
}

void softberryOrthoFreeList(struct softberryOrtho **pList)
/* Free a list of dynamically allocated softberryOrtho's */
{
struct softberryOrtho *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    softberryOrthoFree(&el);
    }
*pList = NULL;
}

void softberryOrthoOutput(struct softberryOrtho *el, FILE *f, char sep, char lastSep) 
/* Print out softberryOrtho.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->humanGene);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->mouseGene);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->humanScore);
fputc(sep,f);
fprintf(f, "%u", el->humanRank);
fputc(sep,f);
fprintf(f, "%u", el->mouseRank);
fputc(sep,f);
fprintf(f, "%u", el->blockCount);
fputc(sep,f);
fprintf(f, "%f", el->identity);
fputc(sep,f);
fprintf(f, "%f", el->identityShortest);
fputc(sep,f);
fprintf(f, "%f", el->blockMouse);
fputc(sep,f);
fprintf(f, "%f", el->blockHuman);
fputc(sep,f);
fprintf(f, "%u", el->lenMouse);
fputc(sep,f);
fprintf(f, "%u", el->lenHuman);
fputc(lastSep,f);
}

